//
//  ViewController.m
//  CollectionView
//
//  Created by apple on 16/7/28.
//  Copyright © 2016年 apple. All rights reserved.
//
#define ScreenHeight [[UIScreen mainScreen] bounds].size.height//获取屏幕高度
#define ScreenWidth [[UIScreen mainScreen] bounds].size.width//获取屏幕宽度
#define RGBColor(r, g, b) [UIColor colorWithRed:(r)/255.0 green:(g)/255.0 blue:(b)/255.0 alpha:1.0]


#import "ViewController.h"

@interface ViewController ()<UICollectionViewDelegate,UICollectionViewDataSource,UICollectionViewDelegateFlowLayout>
{
    NSArray *imageAr;
}

@property (nonatomic,assign) float appWidth;

@property (nonatomic,assign) float appHeight;

@property (nonatomic,assign) float scaleX;

@property (nonatomic,assign) float scaleY;
@property (nonatomic, strong)UICollectionView *myCollctionView;
@property (strong, nonatomic) CAGradientLayer *gradientLayer;
@end

@implementation ViewController

static NSString * const reuseIdentifier = @"Cell";

- (UICollectionView *)myCollctionView {
    
    if (!_myCollctionView) {
        // 创建布局对象
        UICollectionViewFlowLayout *flowLayout = [[UICollectionViewFlowLayout alloc] init];
        
        // 卷动的方向(水平、垂直)
        //        flowLayout.scrollDirection = UICollectionViewScrollDirectionHorizontal;
        
        // 每一个cell的大小
        flowLayout.itemSize = CGSizeMake(ScreenWidth/3, 232/2*self.scaleY-0.5);
        
        
        
        // 每一个cell的margin
        flowLayout.sectionInset = UIEdgeInsetsMake(0 , 0, 0, 0);
        
        // 列与列(水平)/行与行(垂直)之间的最小距离
        flowLayout.minimumLineSpacing = 0;
        
        // 两个连续的cell之间的最小距离
        flowLayout.minimumInteritemSpacing = 0;
        
        
        _myCollctionView = [[UICollectionView alloc] initWithFrame:CGRectMake(0, 10, ScreenWidth, 232/2*self.scaleY*3-3) collectionViewLayout:flowLayout];
        _myCollctionView.delegate = self;
        _myCollctionView.dataSource = self;
        
        [_myCollctionView registerClass:[UICollectionViewCell class] forCellWithReuseIdentifier:reuseIdentifier];
        
        
        [self.view addSubview:_myCollctionView];
    }
    return _myCollctionView;
}



- (void)viewDidLoad {
    [super viewDidLoad];
    
    CGRect rect = [[UIScreen mainScreen] bounds];
    self.appWidth = rect.size.width;
    self.appHeight = rect.size.height;
    self.scaleX = self.appWidth/320;
    self.scaleY = self.appHeight/568;
    
    imageAr = @[@"icon_clxx",@"icon_clsj",@"icon_wzcs",@"icon_dyzt",@"icon_zdsg",@"icon_clgz",@"icon-bywx",@"icon_cdfa",@"icon_bxlp"];
    self.myCollctionView.backgroundColor = [UIColor whiteColor];
    
}

#pragma mark --- UICollectionViewDelegate && UICollectionViewDataSource ---

- (NSInteger)collectionView:(UICollectionView *)collectionView numberOfItemsInSection:(NSInteger)section {
    
    
    return 9;
    
}


- (UICollectionViewCell *)collectionView:(UICollectionView *)collectionView cellForItemAtIndexPath:(NSIndexPath *)indexPath {
    
    UICollectionViewCell *cell = [collectionView dequeueReusableCellWithReuseIdentifier:reuseIdentifier forIndexPath:indexPath];
    cell.layer.masksToBounds = YES;
    cell.layer.borderColor=[UIColor colorWithRed:238/255.0 green:238/255.0 blue:238/255.0 alpha:1].CGColor;
    cell.layer.borderWidth= 0.5;
    
    UIImageView *imageView = [[UIImageView alloc] initWithFrame:CGRectMake((cell.frame.size.width-41*self.scaleX)/2, (cell.frame.size.height-66*self.scaleY)/2, 41*self.scaleX, 66*self.scaleY)];
    [cell.contentView addSubview:imageView];
    imageView.userInteractionEnabled = YES;
    imageView.image = [UIImage imageNamed:imageAr[indexPath.row]];
    //    UITapGestureRecognizer *imgTap = [[UITapGestureRecognizer alloc] initWithTarget:self action:@selector(imgClik:)];
    //    [imageView addGestureRecognizer:imgTap];
    //
    //
    //
    //    [imgBtn setBackgroundImage:[UIImage imageNamed:imageAr[indexPath.row]] forState:UIControlStateNormal];
    
    return cell;
}

- (void)collectionView:(UICollectionView *)collectionView didSelectItemAtIndexPath:(NSIndexPath *)indexPath {
    
    
    
    
}


-(void)collectionView:(UICollectionView *)collectionView didUnhighlightItemAtIndexPath:(NSIndexPath *)indexPath{
    NSLog(@"didUnhighlightItemAtIndexPath");
    UICollectionViewCell *cell = (UICollectionViewCell *)[_myCollctionView cellForItemAtIndexPath:indexPath];
    _myCollctionView.backgroundColor = [UIColor whiteColor];
    cell.backgroundColor = [UIColor clearColor];
    cell.layer.shadowOpacity = 0;
    
    CAGradientLayer *layer = [CAGradientLayer layer];
    [_myCollctionView.layer replaceSublayer:_gradientLayer with:layer];
    
    
}

-(void)collectionView:(UICollectionView *)collectionView didHighlightItemAtIndexPath:(NSIndexPath *)indexPath{
    
    UICollectionViewCell *cell = (UICollectionViewCell *)[_myCollctionView cellForItemAtIndexPath:indexPath];
    
    cell.backgroundColor = [UIColor whiteColor];
    
    
    
    UIBezierPath *shadowPath = [UIBezierPath bezierPathWithRect:cell.bounds];
    
    cell.layer.masksToBounds = NO;
    
    cell.layer.shadowColor = [UIColor blackColor].CGColor;
    
    cell.layer.shadowOffset = CGSizeMake(0.0f, 5.0f);
    
    cell.layer.shadowOpacity = 0.3f;
    
    cell.layer.shadowPath = shadowPath.CGPath;
    
    //    cell.contentView.layer.shadowColor = [UIColor colorWithRed:0.0 green:186/255.0 blue:163/255.0 alpha:0.1].CGColor;//shadowColor阴影颜色
    //    cell.layer.shadowOffset = CGSizeMake(1,3);//shadowOffset阴影偏移,x向右偏移4，y向下偏移4，默认(0, -3),这个跟shadowRadius配合使用
    //    cell.layer.shadowOpacity = 0.5;//阴影透明度，默认0
    //    cell.layer.shadowRadius = 8;//阴影半径，默认3
    
    //初始化渐变层
    self.gradientLayer = [CAGradientLayer layer];
    self.gradientLayer.frame = _myCollctionView.bounds;
    [_myCollctionView.layer insertSublayer:_gradientLayer atIndex:0];
    
    
    //设置渐变颜色方向
    self.gradientLayer.startPoint = CGPointMake(0, 0);
    self.gradientLayer.endPoint = CGPointMake(0, 1);
    
    //设定颜色组
    self.gradientLayer.colors = @[
                                  (__bridge id)RGBColor(238, 253, 249).CGColor,
                                  (__bridge id)[UIColor whiteColor].CGColor];
    
    //设定颜色分割点
    self.gradientLayer.locations = @[@(0) ,@(1.0f)];
}


#pragma mark
-(BOOL)collectionView:(UICollectionView *)collectionView shouldHighlightItemAtIndexPath:(NSIndexPath *)indexPath{
    return YES;
}


- (void)didReceiveMemoryWarning {
    [super didReceiveMemoryWarning];
    
}

@end
